"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeRecursive = void 0;
function mergeRecursive(a, b) {
    var result = Object.assign(Object.create(Object.getPrototypeOf(a)), a);
    for (var key in b) {
        if (!result[key])
            result[key] = b[key];
        if (Array.isArray(result[key])) {
            if (!Array.isArray(b[key]))
                throw new Error('The two entities have mismatched structures and cannot be merged.');
            result[key] = b[key];
        }
        else if (typeof result[key] === 'object') {
            if (typeof b[key] !== 'object')
                throw new Error('The two entities have mismatched structures and cannot be merged.');
            result[key] = mergeRecursive(result[key], b[key]);
        }
        else {
            result[key] = b[key];
        }
    }
    return result;
}
exports.mergeRecursive = mergeRecursive;
